#!/bin/sh
#
# HighPoint Storage Management Software Installation Script
#

[ $# -lt 1 ] && exit 1

HERE=`pwd`
#GTKVER=`gtk-config --version`
GTKVER="1.2.6"

if [ $? -ne 0 ] ; then
	echo "gtk library not installed"
	exit 1
fi

HPTRAID=`echo -n hptraid;echo $GTKVER`
SVC_PID=`pidof -s hptsvr`
SVC_FILENAME=hptsvr

case $1 in
-i) 
	pidof hptraid > /dev/null
	if [ $? -eq 0 ] ; then
	  echo "The software is running. Please stop it first."
	  exit 1
	fi 

	pidof -s hptsvr > /dev/null
	if [ $? -eq 0 ] ; then
		echo -n "The service is running. Do you want to stop it?(y/n) (enter=y)"
	 	read yorn
		 	case $yorn in
		 	[nN])
		 		echo "Installation abored."
		 		exit 1
		 		;;
		 	*)
		 		kill $SVC_PID >/dev/null 2>/dev/null
		 		;;
		 	esac
	fi 

#	SVC_FILENAME=`echo -n $SVC_FILENAME;echo $SVC_VER`
	
	if [ ! -f $HERE/hptraid.tar.gz ] ; then
		echo "Software package not found"
		exit 1
	fi

	if [ -f /usr/bin/hptraid ] ; then
		echo -n "The software has been installed. Do you want reinstall it?(y/n) (enter=y)"
	 	read yorn
	 	case $yorn in
	 	[nN])
	 		exit 1
	 		;;
	 	*)
	 		;;
	 	esac

		rm -f /var/log/hpt.log
		rm -f /etc/hptuser.dat		
		rm -f /etc/hptmailset.dat		
		rm -f /usr/bin/hptsys.log
		rm -f /usr/bin/hptraid
		rm -rf /usr/bin/res
		rm -rf /usr/bin/help
		rm -f /usr/bin/hptsvr
		rm -f /usr/bin/hptsvrman.sh
		rm -rf /usr/share/gnome/apps/Applications/hptraid.desktop
		rm -rf /usr/share/applnk/Applications/hptraid.desktop
		rm -rf /usr/share/applications/hptraid.desktop						
		rm -f /etc/rc0.d/k99hptsvr
		rm -f /etc/rcS.d/S99hptsvr
		rm -f /etc/rc3.d/S99hptsvr
		rm -f /etc/rc4.d/S99hptsvr
		rm -f /etc/rc5.d/S99hptsvr
		rm -f /etc/rc1.d/K99hptsvr
		rm -f /etc/rc2.d/K99hptsvr
		rm -f /etc/rc6.d/K99hptsvr
		rm -f /usr/bin/hpthelp
		/etc/init.d/hptdaemon stop
		rm -f /etc/init.d/hptdaemon
		rm -f /etc/hptcfg
	fi
	
	cd /tmp
	gzip -dc $HERE/hptraid.tar.gz | tar -xv >/dev/null 2>/dev/null
	if [ -f $HPTRAID ] ; then
		cp -f $HPTRAID /usr/bin/hptraid
	else
		echo "There is no suitable gtk library on your system."
		echo "The software may still work, but unexpected error may occur."
		cp -f hptraid1.2.6 /usr/bin/hptraid
	fi
	chmod 544 /usr/bin/hptraid >/dev/null 2>/dev/null
	mkdir -p /usr/share/gnome/apps/Applications/ >/dev/null 2>/dev/null
	mkdir -p /usr/share/applnk/Applications/ >/dev/null 2>/dev/null
	mkdir -p /usr/share/applications/ >/dev/null 2>/dev/null
	cp -f hptraid.desktop /usr/share/gnome/apps/Applications/
	cp -f hptraid.desktop /usr/share/applnk/Applications/
	cp -f hptraid.desktop /usr/share/applications/
	cp -rf res /usr/bin/
	cp -rf help /usr/bin/
	cp -f $SVC_FILENAME /usr/bin/hptsvr
	chmod 544 /usr/bin/hptsvr >/dev/null 2>/dev/null		
	cp -f hptsvrman.sh /usr/bin/	
	chmod a+x /usr/bin/hptsvrman.sh	
	cp -f $HERE/hptinstall.sh /usr/bin/	
	chmod a+x /usr/bin/hptinstall.sh
	cp -f hptcfg /etc/hptcfg
	cp -f hptdaemon /etc/init.d/
	chmod a+x /etc/init.d/hptdaemon
	ln -s /etc/init.d/hptdaemon /etc/rc0.d/k99hptsvr
	ln -s /etc/init.d/hptdaemon /etc/rcS.d/S99hptsvr
	ln -s /etc/init.d/hptdaemon /etc/rc3.d/S99hptsvr
	ln -s /etc/init.d/hptdaemon /etc/rc4.d/S99hptsvr
	ln -s /etc/init.d/hptdaemon /etc/rc5.d/S99hptsvr
	ln -s /etc/init.d/hptdaemon /etc/rc1.d/K99hptsvr
	ln -s /etc/init.d/hptdaemon /etc/rc2.d/K99hptsvr
	ln -s /etc/init.d/hptdaemon /etc/rc6.d/K99hptsvr
	if [ -f /usr/bin/netscape ] ; then
		ln -s /usr/bin/netscape /usr/bin/hpthelp
	elif [ -f /usr/bin/mozilla ] ; then
		ln -s /usr/bin/mozilla /usr/bin/hpthelp
	else 
		echo "Warning: Can not find a HTML browser."
		echo "To view help, please make the symbol link /usr/bin/hpthelp to"
		echo "your browser manually."
	fi                               

	rm -f hptraid1.2.6	      
	rm -f hptraid.desktop
	rm -f hptsvr
	rm -f hptsvrman.sh
	rm -rf res
	rm -rf help
	rm -f hptdaemon
	rm -f hptcfg
	/etc/init.d/hptdaemon start
	echo "HighPoint Storage Management Software has been installed successfully!"
	cd $HERE
	;;
-u)
	pidof hptraid > /dev/null
	if [ $? -eq 0 ] ; then
	  echo "The software is running. Please stop it first."
	  exit 1
	fi 
	
	pidof hptsvr > /dev/null
	if [ $? -eq 0 ] ; then
		echo -n "The service is running. Do you want to stop it? (enter=y)"
	 	read yorn
		 	case $yorn in
		 	[nN])
		 		echo "Uninstallation aborted."
		 		exit 1
		 		;;
		 	*)
		 		kill $SVC_PID >/dev/null 2>/dev/null
		 		;;
		 	esac
	fi 
	
	if [ -f /usr/bin/hptraid ] ; then	
		echo -n "Are you sure to uninstall HighPoint Storage Management Software?(y/n) (enter=y)"
		read yesorno
		case $yesorno in
		[nN])			
			;;		
		*)		
			rm -f /var/log/hpt.log			
			rm -f /etc/hptuser.dat		
			rm -f /etc/hptmailset.dat					
			rm -f /usr/bin/hptsys.log
			rm -rf /usr/bin/hptraid
			rm -rf /usr/bin/res
			rm -rf /usr/bin/help
			rm -f /usr/bin/hptsvrman.sh
			rm -f /usr/bin/hptinstall.sh	 
			rm -f /usr/share/gnome/apps/Applications/hptraid.desktop
			rm -f /usr/share/applnk/Applications/hptraid.desktop
			rm -f /usr/share/applications/hptraid.desktop					rm -f /etc/rc0.d/K99hptsvr
			rm -f /etc/rcS.d/S99hptsvr	
			rm -f /etc/rc3.d/S99hptsvr
			rm -f /etc/rc4.d/S99hptsvr
			rm -f /etc/rc5.d/S99hptsvr
			rm -f /etc/rc1.d/K99hptsvr
			rm -f /etc/rc2.d/K99hptsvr
			rm -f /etc/rc6.d/K99hptsvr
			rm -f /etc/hptcfg
			rm -f /usr/bin/hpthelp	 
			/etc/init.d/hptdaemon stop
			rm -f /usr/bin/hptsvr
			rm -f /etc/init.d/hptdaemon
			echo "Uninstall fininshed!" 
			;;
		esac
	fi 	
    ;;
*)
	exit 1
	;; 
esac
exit 0
